//Последнее обновление 2018-07-25 by Phisik
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Здесь всяческий вывод на экран
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "configuration.h"
#include "declarations.h"

char flNumStrPrint = 0;

#if SHOW_FLOAT_TEMPERATURES
#define PRINT_TEMPERATURES() { String msg = "T=" + String(0.1*DS_TEMP(TEMP_KUB), 1) + "," + String(0.1*DS_TEMP(TEMP_DEFL), 1) + "," + String(0.1*DS_TEMP(TEMP_TSA), 1);\
    strcpy(lcd_buffer, msg.c_str());\
    my_lcdprint(lcd_buffer);\
  }
#else
#define PRINT_TEMPERATURES() { sprintf_P(lcd_buffer, PSTR("D2 T=%3i,%3i,%3i"), DS_TEMP(TEMP_KUB), DS_TEMP(TEMP_DEFL), DS_TEMP(TEMP_TSA));\
                 my_lcdprint(lcd_buffer);\
  }
#endif

void my_lcdprint(char *s)
{
  char i;
  char len;
  len = strlen(lcd_buffer);
  for (i = len; i < 16; i++)
    s[i] = ' ';
  s[16] = 0;

  if (IspReg == 111 && s[9] == 'R' && flNumStrPrint == 0) s[9] = 'N';

  lcd.print(s);

  // MQTT code by max506 & limon
#if USE_MQTT_BROKER

  if (flNumStrPrint == 0) {

    snprintf_P(lcd_mqtt_buf1, MQTT_BUFFER_SIZE, fmt_lcd1, s);

    // Убрать завершающие пробелы
    for (i = strlen(lcd_mqtt_buf1) - 1; ; i--) {
      if (lcd_mqtt_buf1[i] == ' ') lcd_mqtt_buf1[i] = '\0';
      else break;
    }
  }
  else if (flNumStrPrint == 1) {
    snprintf_P(lcd_mqtt_buf2, MQTT_BUFFER_SIZE, fmt_lcd2, s);

    // Убрать завершающие пробелы
    for (i = strlen(lcd_mqtt_buf2) - 1; ; i--) {
      if (lcd_mqtt_buf2[i] == ' ') lcd_mqtt_buf2[i] = '\0';
      else break;
    }
  }
#endif // USE_MQTT_BROKER

  flNumStrPrint++;

}

unsigned char hour, minute, second;
int V1, V2, V3;

void formTRZGDistill()
{
  if (TempDeflBegDistil > 0) sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), DS_TEMP(TEMP_DEFL), TempDeflBegDistil, Power);
  else  sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), DS_TEMP(TEMP_KUB), -TempDeflBegDistil, Power);

}

void formTSAErr()
{
  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u TSA!"), hour, minute, second);
  my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
  sprintf_P(lcd_buffer, PSTR("tT=%3i/%3i"), DS_TEMP(TEMP_TSA), MAX_TEMP_TSA);
}

void DisplayDistDefl()
{
  if (DispPage == 0)
  {
    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 50 градусов
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD Rzg"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), DS_TEMP(TEMP_DEFL), TempDeflBegDistil, UstPower);
        break;
      case 3: //Ожидание закипания (прогреется куб дефлегматор)
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD Rzg"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), DS_TEMP(TEMP_KUB), TempDeflBegDistil, UstPower);
        break;
      case 4: //Работа без дефлегматора
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD BezD"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), DS_TEMP(TEMP_DEFL), TempDefl, UstPower);
        break;
      case 5: //Работа с 50% дефлегмацией
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD 50%%"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), DS_TEMP(TEMP_DEFL), TempDefl - DeltaDefl, UstPower);
        break;
      case 6: //Работа с 100% дефлегмацией
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD 100%%"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), DS_TEMP(TEMP_DEFL), TempDefl - DeltaDefl, UstPower);
        break;
      case 7: //Ожидание для охлаждения
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD Wait"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), DS_TEMP(TEMP_KUB), SecondsEnd);
        break;
      case 100: //Окончание
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DD end"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), DS_TEMP(TEMP_KUB));
        break;
    }
  }
  else
  {
    PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("V=%4u, %4iW"), U_UROVEN, deltaPower);
  }

}
void DisplaySimpleDistill()
{
  if (DispPage == 0)
  {
    if (IspReg == 104)
    {
      V1 = 1;
      V2 = Temp1P;
    }
    if (IspReg == 106)
    {
      V1 = 2;
      V2 = Temp2P;
    }
    if (IspReg == 107 || IspReg == 105)
    {
      V1 = 3;
      V2 = Temp3P;
    }

    if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1u-Otbor"), hour, minute, second, V1);
    else  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u sGl"), hour, minute, second);

    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 50 градусов
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1u-O Rzg"), hour, minute, second, V1);
        else sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u sGl Rzg"), hour, minute, second, V1);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 3: //Дистилляция
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), DS_TEMP(TEMP_KUB), V2, UstPower);
        break;
      case 4: //Ожидание 60 секунд для охлаждения
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), DS_TEMP(TEMP_KUB), SecondsEnd);
        break;
      case 100: //Окончание
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), DS_TEMP(TEMP_KUB));
        break;
      case 101: //Температура в ТСА превысила предельную
        formTSAErr();
        break;
    }
  }
  else
  {
    PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("%4iW,%3uV,%3uA"), FactPower, (uint16_t)MaxVoltsOut, (uint16_t)MaxIOut);
    //sprintf_P(lcd_buffer, PSTR("V%4u,%4u %4uW"), U_VODA, U_UROVEN, UstPower);
  }

}
void DisplayFracionDistill()
{
  if (DispPage == 0)
  {
    sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DsF %1i/%1i"), hour, minute, second, (int)(TekFraction < CountFractionDist) ? TekFraction + 1 : CountFractionDist, (int)CountFractionDist);

    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 70 градусов
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DsF Rzg"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 3: //Дистилляция
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        if (TekFraction < CountFractionDist) V2 = TempFractionDist[TekFraction];
        if (V2 >= 0) sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), DS_TEMP(TEMP_KUB), V2, UstPower);
        else sprintf_P(lcd_buffer, PSTR("t=%5imin %4iW"), (int)SecOstatok, UstPower);
        break;
      case 4: //Ожидание 60 секунд для охлаждения
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), DS_TEMP(TEMP_KUB), time3);
        break;
      case 100: //Окончание
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), DS_TEMP(TEMP_KUB));
        break;
      case 101: //Температура в ТСА превысила предельную
        formTSAErr();
        break;
    }
  }
  else
  {
    PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("V%4u %4uW"), U_UROVEN, UstPower);
  }

}

void DisplayTestKLP()
{
  if (DispPage == 0)
  {
    sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u tst Dev"), hour, minute, second);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("St=%3i CHIM=%3i"), StateMachine, ProcChimSR);
  }
  else
  {
    PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("%3u, %3u "), DS_TEMP(3), DS_TEMP(4));
  }
}

void DisplayData()
{
  int tic1;
  static int PrevState = 0;
  static char flDspDop = 0; // Флаг для отображения информации (через раз)
  char j; // Временная переменная для цикла
  flNumStrPrint = 0;
  flDspDop = !flDspDop;

  hour = Seconds / 3600;
  tic1 = Seconds % 3600;
  minute = tic1 / 60;
  second = tic1 % 60;

  if (FlState >= 0)
    lcd.setCursor(0, 0);
  else
  {
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState == 0)  delay(100);

    if (FlState != PrevState)
    {
      lcd.clear();  //очистка дисплея
      PrevState = FlState;
    }

    lcd.setCursor(0, 0);
  }
  switch (FlState)
  {
    case 0:

      if (DispPage < 2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
      {
        switch (IspReg)
        {
          case 101: // Displaying
            //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
            //  это напряжение нужно для калибровки нашего измерителя

            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("Disp1 %02u:%02u:%02u"), hour, minute, second);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("Zr=%4u U=%3i"), TicZero, (uint16_t)MaxVoltsOut);
             }

             if (DispPage == 1)
             {
          PRINT_TEMPERATURES();
          sprintf_P(lcd_buffer, PSTR("Urv =%4u"), U_UROVEN);
             }
             break;
          case 102: // Термостат
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u TermSt"), hour, minute, second, Delta);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              sprintf_P(lcd_buffer, PSTR("t=%3i/%3i(%2i) %1i"), DS_TEMP(TEMP_TERMOSTAT), TempTerm, Delta, StateMachine);
            }
            else
            {
              PRINT_TEMPERATURES();
            }
            break;
          case 115: // Таймер
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Timer"), hour, minute, second, Delta);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              minute = Seconds / 60;
              sprintf_P(lcd_buffer, PSTR("tm=%3i/%3i %4iW"), minute, timerMinute, UstPower);
            }
            else
            {
              PRINT_TEMPERATURES();
              sprintf_P(lcd_buffer, PSTR("PM= %4iW"), PowerMinute);
            }
            break;
          case 103: // Регулятор мощности
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("RM=%3u% 02u:%02u:%02u"),(uint16_t)MaxVoltsOut, hour, minute, second);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              sprintf_P(lcd_buffer, PSTR("P=%4u/%4u c%3u"), UstPowerReg, Power, indexOut);
            }
            else
            {
              sprintf_P(lcd_buffer, PSTR("Up to auto=%4uW"), Power);
              if (flAutoDetectPowerTEN)
              sprintf_P(lcd_buffer, PSTR("Up to auto=%4uW"), Power);
             }
            break;
          case 105: // Отбор голов
          case 104: // Перевый (недробный) отбор
          case 106: // Второй дробный отбор
          case 107: // Третий дробный отбор
            DisplaySimpleDistill();
            break;
          case 117: // Фракционная перегонка
            DisplayFracionDistill();
            break;
          case 110: // Дистилляция с дефлегматором
            DisplayDistDefl();
            break;
          case 129: // тест клапанов
            DisplayTestKLP();
            break;
          case 249:
            sprintf_P(lcd_buffer, PSTR("NO DETECT ZERO!"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf_P(lcd_buffer, PSTR("Umax=%i"), (uint16_t)MaxVoltsOut);
            break;
           case 251:
            sprintf_P(lcd_buffer, PSTR("ERR Ds18b20!"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf_P(lcd_buffer, PSTR("Num=%i"), (int)NumErrDs18);
            break;
        }
      }

      // Третья страница отображения универсальна.
      if (DispPage == 2)
      {
       sprintf_P(lcd_buffer, PSTR("D3 Power TEN"));
       my_lcdprint(lcd_buffer);   
       sprintf_P(lcd_buffer, PSTR("%4iW,%3uV,%3uA"), FactPower, (uint16_t)MaxVoltsOut, (uint16_t)MaxIOut);
      }
      // На четвертой странице показываем всю температуру
      if (DispPage == 3)
      {
        sprintf_P(lcd_buffer, PSTR("D4 KUB=%3i"), DS_TEMP(TEMP_KUB));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("DEFL=%3i, TSA=%3i"), DS_TEMP(TEMP_DEFL), DS_TEMP(TEMP_TSA));
      }
      // На пятой странице показываем состояние датчиков уровней
      if (DispPage == 4)
      {
        sprintf_P(lcd_buffer, PSTR("D5 UROVEN "));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("URV= %4u"), U_UROVEN);
      }
      // На шестой странице состояние регулятора мощности
      if (DispPage == 5)
      {
        sprintf_P(lcd_buffer, PSTR("D6 Reg Power"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("zPS=%3u,UPR=%4uW"), (int)zPSOut, UstPowerReg); 
      }
      // На седьмой странице показываем состояние управления симисторами.
      if (DispPage == 6)
      {
        sprintf_P(lcd_buffer, PSTR("D7 T=%4u,Z=%4u"), TimeOpenTriac, TicZero);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("KLP=%4u,Bz=%3u"), TimeOpenKLP, (int)b_value[0]);
      }
      // На восьмой можно сменить состояние процесса.
      if (DispPage == 7)
      {
        sprintf_P(lcd_buffer, PSTR("D8 State Machine"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("State = %i"), (int)StateMachine);
      }
      // На девятой состояние ПИД-регулятора
      if (DispPage == 8)
      {
        sprintf_P(lcd_buffer, PSTR("D9 N=%4i O=%4i"), NewErr, OldErrOut);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("Dt=%4i It=%4i"), Dt, It);
      }
      // На Десятой странице показываем максимальные температуры за процесс температуру и давление
      if (DispPage == 9)
      {
        sprintf_P(lcd_buffer, PSTR("D10 MaxT=%3i,%3i"), MAX_DS_TEMP(0), MAX_DS_TEMP(1));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("%3i,%3i,%3i"), MAX_DS_TEMP(2), MAX_DS_TEMP(3), MAX_DS_TEMP(4));
      }
      // На 11  странице показываем параметры расчета ПИД-регулятора
      if (DispPage == 10)
      {
        sprintf_P(lcd_buffer, PSTR("D11 N,O=%3i %3i"), NewErrTemp, OldErrTempOut);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("KId%4i %4i %3i"), KtT, ItTemp, DtTemp);
      }

      if (flDspDop && DispDopInfo > 0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
      {

        if (BeepStateProcess > 1)
        {
          if (DispDopInfo == 3 || DispDopInfo == 4)
          {
            if (!(BeepStateProcess & B00000010) && DispDopInfo == 3) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
            if (!(BeepStateProcess & B00000100) && DispDopInfo == 4) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
          }
          else
            my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
        }
        else
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
        if (DispDopInfo == 1) sprintf_P(lcd_buffer, PSTR("Smena TARA!(%3i)"), (IspReg == 117 || IspReg == 118) ? CountAlarmUroven : COUNT_ALARM_UROVEN - CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
        if (DispDopInfo == 3) sprintf_P(lcd_buffer, PSTR("Low Power! %3iV"), (uint16_t)MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
        if (DispDopInfo == 6) sprintf_P(lcd_buffer, PSTR("HIGH Power! %3iV"), (uint16_t)MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
        if (DispDopInfo == 4) sprintf_P(lcd_buffer, PSTR("Err temp! ds=%2i"), (int)NumErrDs18); //Выводим на экран инфомацию о ошибке чтения датчика.
      }

      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 100:
      sprintf_P(lcd_buffer, PSTR("Settings Menu"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("              "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 101:
      sprintf_P(lcd_buffer, PSTR("Monitoring Mode "));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 102:
      sprintf_P(lcd_buffer, PSTR("Thermostat"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 103:
      sprintf_P(lcd_buffer, PSTR("Power Regulator"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 104:
      sprintf_P(lcd_buffer, PSTR("1st distillation"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(non-fractional)"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 105:
      sprintf_P(lcd_buffer, PSTR("IsR = otbor GLV"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 106:
      sprintf_P(lcd_buffer, PSTR("IsR = 2 DR otbor"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 107:
      sprintf_P(lcd_buffer, PSTR("IsR = 3 DR otbor"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 110:// Дистилляция с дефлегматором
      sprintf_P(lcd_buffer, PSTR("IsR = Dist Defl"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 115:// Таймер
      sprintf_P(lcd_buffer, PSTR("Power regulator"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("+ Shutdown Timer"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 117:// Фракционная дистилляция
      sprintf_P(lcd_buffer, PSTR("IsR = Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Fractional"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 129:
      sprintf_P(lcd_buffer, PSTR("Valve Test Mode"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 200:
      sprintf_P(lcd_buffer, PSTR("Max_t_Tst=%5i"), TempTerm);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 201:
      sprintf_P(lcd_buffer, PSTR("TEH Nominal"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Power=%5u"), Power);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 202:
      sprintf_P(lcd_buffer, PSTR("Current TEH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Power=%5u"), UstPowerReg);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 203:
      sprintf_P(lcd_buffer, PSTR("ParamUSART=%u"), FlToUSART);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 205:
      sprintf_P(lcd_buffer, PSTR("dtTermostat=%3i"), Delta);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 206:
      sprintf_P(lcd_buffer, PSTR("1st Distillation"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_end=%3i"), Temp1P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 207:
      sprintf_P(lcd_buffer, PSTR("Temp 2 Drobn"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%3i"), Temp2P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 208:
      sprintf_P(lcd_buffer, PSTR("Temp 3 Drobn"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%3i"), Temp3P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 211:
      sprintf_P(lcd_buffer, PSTR("Corrections for"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("ds18b20 values"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 219:
      sprintf_P(lcd_buffer, PSTR("Power GLV simple"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%4i"), PowerGlvDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 220:
      sprintf_P(lcd_buffer, PSTR("Power simple"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%4i"), PowerDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 221:
      sprintf_P(lcd_buffer, PSTR("Temp Begin Dist"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(+Def -Kub)=%3i"), TempDeflBegDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 222:
      sprintf_P(lcd_buffer, PSTR("Temp Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("With Defl=%3i"), TempDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 223:
      sprintf_P(lcd_buffer, PSTR("Delta Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("With Defl=%3i"), DeltaDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 224:
      sprintf_P(lcd_buffer, PSTR("Temp Kub Okon"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("DistWithDefl=%3i"), tEndDistDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 225:
      sprintf_P(lcd_buffer, PSTR("BeepEndProc=%1u"), BeepEndProcess);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 226:
      sprintf_P(lcd_buffer, PSTR("BeepStateProc=%1u"), BeepStateProcess);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 227:
      sprintf_P(lcd_buffer, PSTR("BeepKeyPress=%1u"), BeepKeyPress);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 229:
      sprintf_P(lcd_buffer, PSTR("Power Varka"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Zerno=%4i"), PowerVarkaZerno);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 231:
      sprintf_P(lcd_buffer, PSTR("U Peregrev=%3uV"), (unsigned int)NaprPeregrev);
      my_lcdprint(lcd_buffer);
      break;
    case 235:
      sprintf_P(lcd_buffer, PSTR("Edit T & PWM"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Count PWM=%3i"), (int)CntCHIM);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 241:
      sprintf_P(lcd_buffer, PSTR("Power correct"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("ASC712 =%3i"), (int)CorrectASC712);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 249:
      sprintf_P(lcd_buffer, PSTR("PID Paramters"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 257:
      sprintf_P(lcd_buffer, PSTR("Fraction Dist"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Count =%3i"), (int)CountFractionDist);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;

#if ENABLE_SENSOR_SORTING
    case 269:
      sprintf_P(lcd_buffer, PSTR("DS18B20 Order")); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      // Печатаем номера всех наших сенсоров
      for (int i = 0, n = 0; i < MAX_DS1820; i++) {
        n += sprintf_P(lcd_buffer + n, (i > 0) ? PSTR(" %02d") : PSTR("%02d"), (int)ds1820_nums[i] + 1);
      }
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
#endif

    case 300:
      sprintf_P(lcd_buffer, PSTR("Temp%1i=%3u"), nPopr, DS_TEMP(nPopr));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Popr=%3i T=%3u"), ds1820_popr[nPopr], (DS_TEMP(nPopr) + ds1820_popr[nPopr]));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 301:
      sprintf_P(lcd_buffer, PSTR("TempK(%1i)=%4i"), (int)nPopr, tempK[nPopr]);
      if (flPopr == 0)
      {
        sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
      }
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("CHIM(%1i)=%3i"), (int)nPopr, (int)CHIM[nPopr]);
      if (flPopr == 1)
      {
        sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
      }
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 309:
      sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0, 1);
      if (nPopr == 0) sprintf_P(lcd_buffer, PSTR("   P"));
      if (nPopr == 1) sprintf_P(lcd_buffer, PSTR("        I"));
      if (nPopr == 2) sprintf_P(lcd_buffer, PSTR("             D"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;

#if ENABLE_SENSOR_SORTING
    case 316:
      // Печатаем номера всех наших сенсоров
      for (int i = 0, n = 0; i < MAX_DS1820; i++) {
        n += sprintf_P(lcd_buffer + n, (i > 0) ? PSTR(" %02d") : PSTR("%02d"), (int)ds1820_nums[i] + 1);
      }
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0, 1);
      j = 0;
      while (j < (nPopr) * 3 + 1)
      {
        lcd_buffer[j] = ' ';
        j++;
      }
      lcd_buffer[j] = '*';
      lcd_buffer[j + 1] = 0;
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
#endif
    default:
      break;
  }

  if (flNumStrPrint < 2)
  {
    lcd_buffer[0] = 0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  }
  NeedDisplaying = false;

}
