// Последнее обновление 2018-07-25 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Обработка клавиатуры здесь

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Очень длинная и "нудная" функция обработки клавиатуры в разных режимах
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "configuration.h"
#include "declarations.h"

char KeyCode; // Код нажатой клавиши

#define PRESS_SELECT                                                           \
  (KeyCode ==                                                                  \
   1) // Phisik: Скобочки здесь нужно всегда ставить, на всякий случай,
#define PRESS_RIGHT                                                            \
  (KeyCode == 2) // т.к. могут быть очень трудноуловимые ошибки
#define PRESS_LEFT (KeyCode == 3)
#define PRESS_UP (KeyCode == 4)
#define PRESS_DOWN (KeyCode == 5)

void ScanKbd() {
  int menuFlagNumber;
  char i;

#ifdef DEBUG
  if (DEBUG_SERIAL.available())
    return;
#endif

  // Если режим защиты от дребезга уже выключен
  if (CountKeys == 0) {
    flScanKbd = 1; // Установим признак сканирования клавиатуры.

    KeyCode = 0; // Reset keycode

    switch (cmdGPRS) {
    case 'R':
      KeyCode = 2;
      break;
    case 'U':
      KeyCode = 4;
      break;
    case 'D':
      KeyCode = 5;
      break;
    case 'L':
      KeyCode = 3;
      break;
    case 'S':
      KeyCode = 1;
      break;
    }

    cmdGPRS = 0; // clear server command

    // Skip hardware keyboard reading if recieved online command
    if (KeyCode == 0) {
      const int key = analogRead(PIN_LCD_KEYPAD);

      if (key >= 0)
        KeyCode = 2; //  R
      if (key >= 90)
        KeyCode = 4; //  U
      if (key >= 200)
        KeyCode = 5; //  D
      if (key >= 400)
        KeyCode = 3; //  L
      if (key >= 600)
        KeyCode = 1; //  S
      if (key >= 850)
        KeyCode = 0;

#if PRINT_ADC_VALUES
      if (KeyCode > 0) {
        DEBUG_SERIAL.print("ADC value = ");
        DEBUG_SERIAL.println(key);
      }
#endif
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_SELECT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_SELECT) {
      if (BeepKeyPress)
        my_beep(1);
      switch (FlState) {
      case 0:

        FlState = IspReg;
        break;
      case 100:
        menuFlagNumber = -1;

        // Edited by Phisik on 2017-08-16
        // Обновил алгоритм зацикливания. Теперь не надо задавать
        // LAST_ITEM/FIRST_ITEM Просто расставить  1/0

        // ищем следующий ненулевой индекс в menuFlagNumber
        while (!settingsEnableFlag[++menuFlagNumber])
          if (menuFlagNumber >= SETTINGS_ITEMS) {
            menuFlagNumber = 0;
            break; // если кругом нули, показываем первый пункт
          }

        FlState = 200 + menuFlagNumber; // Возвращаемся к стандартной нумерации
        break;
      case 101:
        FlState = 0;
        IspReg = 101;
        writeEEPROM();
        PrepareProcess(); // Phisik: Убираем все ТЕНы и клапана!!!
        break;
      case 102:
        if (IspReg != 102) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 102;
        writeEEPROM();
        FlState = 200;
        break;
      case 200:
        FlState = 0;
        writeEEPROM();
        break;
      case 103:
        IspReg = 103;
        writeEEPROM();
        FlState = 202;
        break;
      case 201:
        writeEEPROM();
        FlState = 0;
        break;
      case 202:
        writeEEPROM();
        FlState = 0;
        break;
      case 104:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 104 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 104;
        writeEEPROM();
        FlState = 206;
        break;
      case 105:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 105 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 105;
        writeEEPROM();
        FlState = 221;
        break;
      case 106:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 106 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 106;
        writeEEPROM();
        FlState = 207;
        break;
      case 107:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 107 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 107;
        writeEEPROM();
        FlState = 208;
        break;
      case 110:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 110 || !StateMachine) // Если состояние автомата - не
                                            // запущено, запускаем процесс
        {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 110;
        writeEEPROM();
        FlState = 220;
        break;
      case 111:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 111 || !StateMachine) // Если состояние автомата - не
                                            // запущено, запускаем процесс
        {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 111;
        writeEEPROM();
        FlState = 209;
        break;
      case 115:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 115 || !StateMachine) // Если состояние автомата - не
                                            // запущено, запускаем процесс
        {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 115;
        writeEEPROM();
        FlState = 0;
        break;
      case 117:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние
        // автомата в начальное.
        if (IspReg != 117 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 117;
        writeEEPROM();
        FlState = 257;
        break;
      case 129:
        if (IspReg != 129 || !StateMachine) {
          Seconds = 0;
          flAlarmUroven = 0;
          StateMachine = 0;
        }
        if (!StateMachine)
          StateMachine = 1;
        IspReg = 129;
        writeEEPROM();
        FlState = 231;
        break;
      case 203:
      case 204:
      case 205:
      case 206:
      case 207:
      case 208:
      case 209:
      case 210:
      //      case 211:
      case 212:
      case 213:
      case 214:
      case 215:
      case 216:
      case 217:
      case 218:
      case 219:
      case 220:
      case 221:
      case 222:
      case 223:
      case 224:
      case 225:
      case 226:
      case 227:
      case 228:
      case 229:
      case 230:
      case 231:
      case 232:
      case 233:
      case 234:
      case 236:
      case 237:
      case 238:
      case 239:
      case 241:
      case 243:
      case 246:
      case 247:
      case 248:
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
      case 259:
      case 260:
      case 261:
      case 264:
      case 265:
      case 266:
      case 267:
      case 268:
        writeEEPROM();
        FlState = 0;
        break;
      case 211:
        FlState = 300;
        nPopr = 0;
        break;
      case 235:
        FlState = 301;
        nPopr = 0;
        flPopr = 0;
        break;
      case 249:
        FlState = 309;
        nPopr = 0;
        flPopr = 0;
        break;
      case 257:
        FlState = 312;
        nPopr = 0;
        flPopr = 0;
        break;
      case 258:
        FlState = 313;
        nPopr = 0;
        flPopr = 0;
        break;
#if ENABLE_SENSOR_SORTING
      case 269:
        FlState = 316;
        nPopr = 0;
        break;
#endif
      case 300:
        writeEEPROM();
        FlState = 211;
        break;
      case 301:
        writeEEPROM();
        FlState = 235;
        break;
      case 302:
        writeEEPROM();
        if (IspReg != 116)
          FlState = 240;
        else
          FlState = 0;
        break;
      case 303:
        writeEEPROM();
        FlState = 242;
        break;
      case 304:
        writeEEPROM();
        FlState = 244;
        break;
      case 305:
        writeEEPROM();
        FlState = 245;
        break;
      case 309:
        writeEEPROM();
        FlState = 249;
        break;
      case 310:
        writeEEPROM();
        FlState = 255;
        break;
      case 311:
        writeEEPROM();
        FlState = 256;
        break;
      case 312:
        writeEEPROM();
        if (IspReg != 117)
          FlState = 257;
        else
          FlState = 0;
        break;
      case 313:
        writeEEPROM();
        if (IspReg != 118)
          FlState = 258;
        else
          FlState = 0;
        break;
      case 315:
        writeEEPROM();
        FlState = 263;
        break;
#if ENABLE_SENSOR_SORTING
      case 316:
        writeEEPROM();
        FlState = 269;
        break;
#endif
      }

      DisplayData();

      if (CountKeys == 0)
        CountKeys = 6;
      CountState = MENU_DELAY_SEC;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_RIGHT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_RIGHT) {
      if (BeepKeyPress)
        my_beep(1);

      int menuFlagNumber = 0;

      switch (FlState) {
      case 0:
        do {
          if (++DispPage > SCREEN_ITEMS - 1)
            DispPage = 0; // зацикливаем поиск
        } while (!screenEnableFlag[DispPage]);

#if !defined(NO_PAGE_BEEP) || NO_PAGE_BEEP != 1
        // Если перешли на третью страницу, то переинициализируем дисплей
        if (DispPage == 4 || DispPage == 10) {
          my_beep(BEEP_LONG * 5);

          // Phisik:  пробуйте по разному, моя библиотека этих строчек не
          // требует
          lcd.init();
          lcd.backlight();

          lcd.clear();
          DisplayData();
        }
#endif
        CountKeys = 4;
        break;
      case 100:
      case 101:
      case 102:
      case 103:
      case 104:
      case 105:
      case 106:
      case 107:
      case 108:
      case 109:
      case 110:
      case 111:
      case 112:
      case 113:
      case 114:
      case 115:
      case 116:
      case 117:
      case 118:
        // Edited by Phisik on 2017-08-15
        // Вычисляем текущий индекс в menuEnableFlag[]
        menuFlagNumber = FlState % 100;

        // ищем следующий ненулевой индекс в menuFlagNumber
        while (!menuEnableFlag[++menuFlagNumber] &&
               menuFlagNumber < MENU_ITEMS - 2)
          ; // здесь ничего не делаем, просто ищем флажок

        if (menuFlagNumber >= MENU_ITEMS - 2)
          FlState = 129; // При необходимости, перескакиваем на тест клапанов
        else
          FlState =
              100 +
              menuFlagNumber; // Или просто возвращаемся к стандартной нумерации
        break;
      case 129:
        // Если нужно внешнее управление, переходим к нему
        if (menuEnableFlag[MENU_ITEMS - 1])
          FlState++;
        else // Если нет - идем в начало
          FlState = 100;
        break;
      case 130:
        FlState = 100;
        break;
      case 200:
      case 201:
      case 202:
      case 203:
      case 204:
      case 205:
      case 206:
      case 207:
      case 208:
      case 209:
      case 210:
      case 211:
      case 212:
      case 213:
      case 214:
      case 215:
      case 216:
      case 217:
      case 218:
      case 219:
      case 220:
      case 221:
      case 222:
      case 223:
      case 224:
      case 225:
      case 226:
      case 227:
      case 228:
      case 229:
      case 230:
      case 231:
      case 232:
      case 233:
      case 234:
      case 235:
      case 236:
      case 237:
      case 238:
      case 239:
      case 240:
      case 241:
      case 242:
      case 243:
      case 244:
      case 245:
      case 246:
      case 247:
      case 248:
      case 249:
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
      case 255:
      case 256:
      case 257:
      case 258:
      case 259:
      case 260:
      case 261:
      case 262:
      case 263:
      case 264:
      case 265:
      case 266:
      case 267:
      case 268:
#if ENABLE_SENSOR_SORTING
      case 269:
#endif
        // Edited by Phisik on 2017-08-16
        // Вычисляем текущий индекс в menuEnableFlag[]
        menuFlagNumber = FlState % 200;

        // Edited by Phisik on 2018-07-03
        // Обновил алгоритм зацикливания. Теперь не надо задавать
        // LAST_ITEM/FIRST_ITEM Просто расставить  1/0 ищем следующий ненулевой
        // индекс в menuFlagNumber
        do {
          if (++menuFlagNumber > SETTINGS_ITEMS - 1)
            menuFlagNumber = 0; // зацикливаем поиск
        } while (!settingsEnableFlag[menuFlagNumber]);

        FlState = 200 + menuFlagNumber; // Возвращаемся к стандартной нумерации
        break;

      case 300:
        if (nPopr < MAX_DS1820 - 1)
          nPopr++;
        break;
      case 301:
        if (flPopr == 0)
          flPopr = 1;
        else {
          if (nPopr < COUNT_CHIM - 1)
            nPopr++;
          flPopr = 0;
        }
        break;
      case 302:
        if (flPopr == 0)
          flPopr = 1;
        else {
          if (nPopr < MAX_CNT_PAUSE - 1)
            nPopr++;
          flPopr = 0;
        }
        break;
      case 303:
        if (nPopr < 3)
          nPopr++;
        break;
      case 304:
        if (nPopr < 9)
          nPopr++;
        break;
      case 305:
        if (nPopr < 11)
          nPopr++;
        break;
      case 309:
        if (nPopr < 2)
          nPopr++;
        break;
      case 310:
      case 311:
        if (nPopr < 10)
          nPopr++;
        break;
      case 312:
        if (flPopr < 2)
          flPopr++;
        else {
          if (nPopr < MAX_CNT_FRACTION_DIST)
            nPopr++;
          flPopr = 0;
        }
        break;
      case 315:
        if (nPopr < 2)
          nPopr++;
        break;
#if ENABLE_SENSOR_SORTING
      case 316:
        if (nPopr < MAX_DS1820 - 1)
          nPopr++;
        break;
#endif
      }

      // NeedDisplaying=1;
      DisplayData();
      if (CountKeys == 0)
        CountKeys = 6;

      CountState = MENU_DELAY_SEC;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_LEFT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_LEFT) {
      if (BeepKeyPress)
        my_beep(1);

      int menuFlagNumber = 0;
      switch (FlState) {
      case 0:
        do {
          if (--DispPage < 0)
            DispPage = SCREEN_ITEMS - 1; // зацикливаем поиск
        } while (!screenEnableFlag[DispPage]);

#if !defined(NO_PAGE_BEEP) || NO_PAGE_BEEP != 1
        if (DispPage == 0) {
          // Если на нулевой странице нажали кнопку влево, то тоже
          // переинициализируем дисплей.
          my_beep(BEEP_LONG * 2);

          // Phisik:  пробуйте по разному, моя библиотека этих строчек не
          // требует
          lcd.init();
          lcd.backlight();

          lcd.clear();
          DisplayData();
        }
#endif
        CountKeys = 4;
        break;
      case 100:
        if (menuEnableFlag[MENU_ITEMS - 1])
          FlState = 130; // идем на внешнее управление
        else
          FlState = 129; // или сразу на тест клапанов
        break;
      case 101:
      case 102:
      case 103:
      case 104:
      case 105:
      case 106:
      case 107:
      case 108:
      case 109:
      case 110:
      case 111:
      case 112:
      case 113:
      case 114:
      case 115:
      case 116:
      case 117:
      case 118:
      case 129:
        // Edited by Phisik on 2017-08-15

        // Вычисляем текущий индекс в menuEnableFlag[]
        menuFlagNumber = FlState % 100;

        // Тут затычка из-за непоследовательной нумерации пунктов
        if (menuFlagNumber == 29)
          menuFlagNumber = MENU_ITEMS - 2;

        // Ищем предыдущий ненулевой индекс в menuFlagNumber
        while (!menuEnableFlag[--menuFlagNumber] && menuFlagNumber > 0)
          ; // здесь ничего не делаем, просто ищем флажок

        // Возвращаемся к стандартной нумерации
        FlState = 100 + menuFlagNumber;
        break;
      case 130:
        FlState--;
        break;
      case 200:
      case 201:
      case 202:
      case 203:
      case 204:
      case 205:
      case 206:
      case 207:
      case 208:
      case 209:
      case 210:
      case 211:
      case 212:
      case 213:
      case 214:
      case 215:
      case 216:
      case 217:
      case 218:
      case 219:
      case 220:
      case 221:
      case 222:
      case 223:
      case 224:
      case 225:
      case 226:
      case 227:
      case 228:
      case 229:
      case 230:
      case 231:
      case 232:
      case 233:
      case 234:
      case 235:
      case 236:
      case 237:
      case 238:
      case 239:
      case 240:
      case 241:
      case 242:
      case 243:
      case 244:
      case 245:
      case 246:
      case 247:
      case 248:
      case 249:
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
      case 255:
      case 256:
      case 257:
      case 258:
      case 259:
      case 260:
      case 261:
      case 262:
      case 263:
      case 264:
      case 265:
      case 266:
      case 267:
      case 268:
#if ENABLE_SENSOR_SORTING
      case 269:
#endif
#if ENABLE_SENSOR_SORTING
      case 270:
#endif
        // Edited by Phisik on 2017-08-16
        // Вычисляем текущий индекс в menuEnableFlag[]
        menuFlagNumber = FlState % 200;

        // ищем следующий ненулевой индекс в menuFlagNumber
        do {
          if (--menuFlagNumber < 0)
            menuFlagNumber = SETTINGS_ITEMS - 1; // зацикливаем поиск
        } while (!settingsEnableFlag[menuFlagNumber]);

        FlState = 200 + menuFlagNumber; // Возвращаемся к стандартной нумерации
        break;
      case 300:
        if (nPopr > 0)
          nPopr--;
        break;
      case 301:
        if (flPopr == 1)
          flPopr = 0;
        else {
          if (nPopr > 0)
            nPopr--;
          flPopr = 1;
        }
        break;
      case 302:
        if (flPopr == 1)
          flPopr = 0;
        else {
          if (nPopr > 0)
            nPopr--;
          flPopr = 1;
        }
        break;
      case 303:
      case 304:
      case 305:
      case 309:
      case 310:
      case 311:
      case 314:
      case 315:
        if (nPopr > 0)
          nPopr--;
        break;
      case 312:
        if (flPopr > 0)
          flPopr--;
        else {
          if (nPopr > 0)
            nPopr--;
          flPopr = 2;
        }
        break;
      case 313:
        if (flPopr > 0)
          flPopr--;
        else {
          if (nPopr > 0)
            nPopr--;
          flPopr = 1;
        }
        break;
#if ENABLE_SENSOR_SORTING
      case 316:
        if (nPopr > 0)
          nPopr--;
        break;
#endif
      }

      // NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse = 1;
      CountState = MENU_DELAY_SEC;
      if (CountKeys == 0)
        CountKeys = 6;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_UP
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_UP) {
      if (BeepKeyPress)
        my_beep(1);
      CountState = 0;
      switch (FlState) {
      case 0:
        // В сотоянии 0 обработка клавиш происходит за выходом модели этого
        // конечного автомата.
        if (DispPage ==
            7) // На 8 странице вручную можно состояние процесса поменять
        {
          StateMachine++;
          break;
        }

        if (DispPage == 5) // На 6 странице можно мощность вручную прибавить
        {
          UstPower += 10;
          break;
        }
        // Регулятор мощности
        if (IspReg == 103) {
          if (DispPage == 1) {
            // На второй странице нажатик кнопки "вверх" приводи к авто-детекции
            // мощности ТЭНа
            flAutoDetectPowerTEN = 1;
          } else {
            UstPowerReg += 10;
            flAutoDetectPowerTEN = 0;
          }
          CountKeys = 1;
        }
        if (IspReg == 104) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil++;
          else {
            if (DispPage == 0)
              Temp1P++;
            else
              PowerDistil += 10;
          }
        }
        if (IspReg == 106) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil++;
          else {
            if (DispPage == 0)
              Temp2P++;
            else
              PowerDistil += 10;
          }
        }
        if (IspReg == 107) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil++;
          else {
            if (DispPage == 0)
              Temp3P++;
            else
              PowerDistil += 10;
          }
        }
        if (IspReg == 117) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil++;
          else {
            if (TekFraction < CountFractionDist) {
              if (DispPage == 0)
                TempFractionDist[TekFraction]++;
              else
                PowerFractionDist[TekFraction] += 10;
            }
          }
        }
        if (IspReg == 105) {
          CountKeys = 1;
          if (StateMachine == 3)
            PowerGlvDistil += 10;
          if (StateMachine == 2)
            TempDeflBegDistil++;
        }
        if (IspReg == 129) {
          CloseAllKLP();
          ProcChimSR++;
        }
        if (IspReg == 115) {
          CountKeys = 2;
          if (DispPage == 0)
            timerMinute += AddPressKeys;
          else
            PowerMinute += AddPressKeys10;
        }
        if (IspReg == 110) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil++;
          else if (DispPage == 0)
            TempDefl++;
          else
            deltaPower += 10;
        }
      case 200:
        TempTerm += AddPressKeys;
        CountKeys = 2;
        break;
      case 201:
        Power += AddPressKeys10;
        CountKeys = 3;
        break;
      case 202:
        UstPowerReg += AddPressKeys10;
        CountKeys = 3;
        break;
      case 203:
        FlToUSART = 1;
        break;
      case 204:
        break;
      case 205:
        Delta++;
        CountKeys = 3;
        break;
      case 206:
        Temp1P += AddPressKeys;
        CountKeys = 2;
        break;
      case 207:
        Temp2P += AddPressKeys;
        CountKeys = 2;
        break;
      case 208:
        Temp3P += AddPressKeys;
        CountKeys = 2;
        break;
      case 253:
        CountKeys = 4;
        break;
      case 219:
        PowerGlvDistil += AddPressKeys10;
        CountKeys = 3;
        break;
      case 220:
        PowerDistil += AddPressKeys10;
        CountKeys = 3;
        break;
      case 221:
        TempDeflBegDistil += AddPressKeys;
        CountKeys = 3;
        break;
      case 222:
        TempDefl++;
        CountKeys = 3;
        break;
      case 223:
        DeltaDefl++;
        CountKeys = 3;
        break;
      case 224:
        tEndDistDefl++;
        CountKeys = 3;
        break;
      case 225:
        BeepEndProcess = 1;
        break;
      case 226:
        BeepStateProcess++;
        CountKeys = 5;
        break;
      case 227:
        BeepKeyPress = 1;
        break;
      case 229:
        PowerVarkaZerno += AddPressKeys10;
        CountKeys = 3;
        break;
      case 231:
        NaprPeregrev += 5;
        CountKeys = 3;
        break;
      case 235:
        CntCHIM++;
        CountKeys = 3;
        break;
      case 236:
        DecrementCHIM++;
        CountKeys = 3;
        break;
      case 237:
        IncrementCHIM++;
        CountKeys = 3;
        break;
      case 238:
        TimeAutoIncCHIM += 60;
        CountKeys = 3;
        break;
      case 241:
        CorrectASC712++;
        CountKeys = 3;
        break;
      case 249:
        PIDTemp[0] += AddPressKeys;
        CountKeys = 2;
        break;
      case 257:
        if (CountFractionDist < MAX_CNT_FRACTION_DIST)
          CountFractionDist++;
        CountKeys = 3;
        break;
      case 262:
        Power += AddPressKeys10;
        CountKeys = 3;
        break;
      case 300:
        ds1820_popr[nPopr]++;
        CountState = 8; // При вводе поправок сохраняем состояние 4 секунды, а
                        // не две, тут спешка не нужна.
        CountKeys = 4;
        break;
      case 301:
        if (flPopr == 0) {
          tempK[nPopr] += AddPressKeys;
          CountKeys = 1;
        } else
          CHIM[nPopr]++;
        break;
      case 309:
        PIDTemp[nPopr] += AddPressKeys;
        CountKeys = 2;
        break;
      case 312:
        if (nPopr == MAX_CNT_FRACTION_DIST) {
          if (TekFraction < MAX_CNT_FRACTION_DIST - 1) {
            TekFraction++;
            SecTempPrev = Seconds;
          }
          CountKeys = 3;
        } else {
          CountKeys = 2;
          if (flPopr == 0)
            TempFractionDist[nPopr] += AddPressKeys;
          if (flPopr == 2)
            PowerFractionDist[nPopr] += AddPressKeys10;
          if (flPopr == 1) {
            CountKeys = 1;
          }
        }
        break;
#if ENABLE_SENSOR_SORTING
      case 316:
        if (ds1820_nums[nPopr] < MAX_DS1820 - 1)
          ds1820_nums[nPopr]++;
        CountKeys = 4;
        break;
#endif
      }

      // NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse = 1;
      if (CountState == 0)
        CountState = 4;
      if (CountKeys == 0)
        CountKeys = 6;
      CountState = MENU_DELAY_SEC;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_DOWN
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_DOWN) {
      if (BeepKeyPress)
        my_beep(1);
      CountState = 0;
      switch (FlState) {
      case 0:

        // В сотоянии 0 обработка клавиш происходит за выходом модели этого
        // конечного автомата.
        if (DispPage == 2) // На третьей странице сбрасываем датчик потока
        {
          break;
        }
        if (DispPage == 7) // На 8 странице можно состояние процесс поменять.
        {
          StateMachine--;
          break;
        }
        if (DispPage == 5) // На 6 странице можно мощность вручную изменить.
        {
          UstPower -= 10;
          break;
        }
        // Регулятор мощности
        if (IspReg == 103) {
          UstPowerReg -= 10;
          CountKeys = 1;
        }
        if (IspReg == 104) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil--;
          else if (DispPage == 0)
            Temp1P--;
          else
            PowerDistil -= 10;
        }
        if (IspReg == 106) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil--;
          else if (DispPage == 0)
            Temp2P--;
          else
            PowerDistil -= 10;
        }
        if (IspReg == 107) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil--;
          else if (DispPage == 0)
            Temp3P--;
          else
            PowerDistil -= 10;
        }
        if (IspReg == 117) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil--;
          else {
            if (TekFraction < CountFractionDist) {
              if (DispPage == 0)
                TempFractionDist[TekFraction]--;
              else
                PowerFractionDist[TekFraction] -= 10;
            }
          }
        }
        if (IspReg == 105) {
          CountKeys = 1;
          if (StateMachine == 3)
            PowerGlvDistil -= 10;
          if (StateMachine == 2)
            TempDeflBegDistil--;
        }
        if (IspReg == 129) {
          CloseAllKLP();
          ProcChimSR--;
        }
        if (IspReg == 115) {
          CountKeys = 2;
          if (DispPage == 0)
            timerMinute -= AddPressKeys;
          else
            PowerMinute -= AddPressKeys10;
        }
        if (IspReg == 110) {
          CountKeys = 1;
          if (StateMachine == 2)
            TempDeflBegDistil--;
          else if (DispPage == 0)
            TempDefl--;
          else
            deltaPower -= 10;
        }
      case 200:
        TempTerm -= AddPressKeys;
        CountKeys = 2;
        break;
      case 201:
        Power -= AddPressKeys10;
        CountKeys = 3;
        break;
      case 202:
        UstPowerReg -= AddPressKeys10;
        CountKeys = 3;
        break;
      case 203:
        FlToUSART = 0;
        break;
      case 205:
        Delta--;
        CountKeys = 3;
        break;
      case 206:
        Temp1P -= AddPressKeys;
        CountKeys = 2;
        break;
      case 207:
        Temp2P -= AddPressKeys;
        CountKeys = 2;
        break;
      case 208:
        Temp3P -= AddPressKeys;
        CountKeys = 2;
        break;
      case 219:
        PowerGlvDistil -= AddPressKeys10;
        CountKeys = 3;
        break;
      case 220:
        PowerDistil -= AddPressKeys10;
        CountKeys = 3;
        break;
      case 221:
        TempDeflBegDistil -= AddPressKeys;
        CountKeys = 3;
        break;
      case 222:
        TempDefl--;
        CountKeys = 3;
        break;
      case 223:
        DeltaDefl--;
        CountKeys = 3;
        break;
      case 224:
        tEndDistDefl--;
        CountKeys = 3;
        break;
      case 225:
        BeepEndProcess = 0;
        break;
      case 226:
        BeepStateProcess = 0;
        break;
      case 227:
        BeepKeyPress = 0;
        break;
      case 229:
        if (PowerVarkaZerno > 10)
          PowerVarkaZerno -= AddPressKeys10;
        else
          PowerVarkaZerno = 0;
        CountKeys = 3;
        break;
      case 231:
        NaprPeregrev -= 5;
        CountKeys = 3;
        break;
      case 235:
        CntCHIM--;
        CountKeys = 3;
        break;
      case 236:
        DecrementCHIM--;
        CountKeys = 3;
        break;
      case 237:
        IncrementCHIM--;
        CountKeys = 3;
        break;
      case 238:
        TimeAutoIncCHIM -= 60;
        CountKeys = 3;
        break;
      case 241:
        CorrectASC712--;
        CountKeys = 3;
        break;
      case 249:
        PIDTemp[0] -= AddPressKeys;
        CountKeys = 2;
        break;
      case 257:
        if (CountFractionDist >= 0)
          CountFractionDist--;
        CountKeys = 3;
        break;
      case 262:
        Power -= AddPressKeys10;
        CountKeys = 3;
        break;
      case 300:
        ds1820_popr[nPopr]--;
        CountState = 8; // При вводе поправок сохраняем состояние 4 секунды, а
                        // не две, тут спешка не нужна.
        CountKeys = 4;
        break;
      case 301:
        if (flPopr == 0) {
          tempK[nPopr] -= AddPressKeys;
          CountKeys = 1;
        } else
          CHIM[nPopr]--;
        break;
      case 309:
        PIDTemp[nPopr] -= AddPressKeys;
        CountKeys = 2;
        break;
      case 312:
        if (nPopr == MAX_CNT_FRACTION_DIST) {
          if (TekFraction > 0) {
            TekFraction--;
            SecTempPrev = Seconds;
          }
          CountKeys = 3;
        } else {
          CountKeys = 2;
          if (flPopr == 0)
            TempFractionDist[nPopr] -= AddPressKeys;
          if (flPopr == 2)
            PowerFractionDist[nPopr] -= AddPressKeys10;
          if (flPopr == 1) {
            CountKeys = 1;
          }
        }
        break;
#if ENABLE_SENSOR_SORTING
      case 316:
        if (ds1820_nums[nPopr] > 0)
          ds1820_nums[nPopr]--;
        CountKeys = 4;
        break;
#endif
      }

      // NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse = 1;
      if (CountState == 0)
        CountState = 4;
      if (CountKeys == 0)
        CountKeys = 6;
      CountState = MENU_DELAY_SEC;
    }
    flNeedScanKbd = 0;
    flScanKbd = 0; // Убираем признак того, что сканируется клавиатура.
  }
}
