// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Здесь будут программы для всех процессов

#include "configuration.h"
#include "declarations.h"


void PrepareProcess()
{
  char i;
  // Максимальную температуру процессов зануляем.
  for (i = 0; i < MAX_DS1820; i++)
  {
    MaxTemps[i] = 0;
  }
  // Все таймеры зануляем.
  time1 = 0;
  time2 = 0;
  time3 = 0;
  flAutoDetectPowerTEN = 0;// Убираем признак авто-детектирования ТЭНОв
  flNoAlarmLowPower = NO_LOW_POWER_WARNING;   // Убираем признак невыдачи предупреждения о низком уровне напряжения

  // Все клапана зануляем
  CloseAllKLP();
  //  Разгон отключаем
  digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
  // Убираем мощность с ТЭНов
  UstPower = 0;
}

void ProcessTermostat()
{

  if (ds1820_devices == 0) StateMachine = 100;

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
    // Процесс термостат запускается автоматически, чтобы он работал даже если выключат и включат свет.
    //break;
    case 1: // Старт процесса
      PrepareProcess();

      digitalWrite(PIN_TERMOSTAT_OFF, LOW);	  // Включаем охлаждение
      digitalWrite(PIN_TERMOSTAT_ON, LOW);		// Выключаем нагрев

      // Вот тут включили разгон
      digitalWrite(PIN_RZG_ON, RELAY_HIGH);

      StateMachine = 2;
    case 2: // Основной цикл программы, пытаемся регулировать мощность, не превышая температуру
      if (DS_TEMP(TEMP_TERMOSTAT) <= TempTerm)
      {
        digitalWrite(PIN_TERMOSTAT_OFF, LOW);	// Включаем охлаждение
        digitalWrite(PIN_TERMOSTAT_ON, HIGH);	// Выключаем нагрев
        ProcessPIDTemp(TempTerm, DS_TEMP(TEMP_TERMOSTAT));
        UstPower = (long)Power * KtT / 1000;

        // Мощность ограничена мощностью варки зерна
        if (UstPower > PowerVarkaZerno) UstPower = PowerVarkaZerno;

        // Если подошли на 5 градусов к целевой температуре, разгон выключаем
        if (DS_TEMP(TEMP_TERMOSTAT) > TempTerm - 50)
          digitalWrite(PIN_RZG_ON, !RELAY_HIGH);

        break;
      }
      // Температура все-таки стала выше нужной - идем к следующему этапу
      StateMachine = 3;
    // if (BeepStateProcess) my_beep(BEEP_LONG);

    case 3: //
      UstPower = 0; // Убираем мощность с ТЭНов
      if (DS_TEMP(TEMP_TERMOSTAT) > TempTerm - Delta)
      {
        digitalWrite(PIN_TERMOSTAT_ON, LOW);		// Выключаем нагрев
        digitalWrite(PIN_TERMOSTAT_OFF, HIGH);		// Включаем охлаждение
        break;
      }
      // Если температура упала ниже TempTerm-Delta, идем регулировать ТЭНы
      StateMachine = 2;
      // if (BeepStateProcess) my_beep(BEEP_LONG);
      break;
    default: // Phisik@24.02.2020: Любое ошибочное значение машины, должно приводить к остановке
    case 100:// Конечное состояние автомата
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      digitalWrite(PIN_TERMOSTAT_ON, LOW);// Выключаем нагрев
      digitalWrite(PIN_TERMOSTAT_OFF, LOW);// Включаем охлаждение
      UstPower = 0; // Убираем мощность с ТЭНов
      break;
  }
}

void ProcessTimerMaxPower()
{
  int minute;
  switch (StateMachine)
  {
    case 0: //
      // Процесс не запущен
      break;
    case 1: // Старт процесса
      PrepareProcess();

      timerMinute = 0;
      StateMachine = 2;

    case 2: // Температура Больше необходиомй
      minute = Seconds / 60;
      if (minute <= timerMinute)
      {
        UstPower = PowerMinute; // Подаем полную мощность на ТЭНЫ
        break;
      }
      StateMachine = 100;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    case 100:// Конечное состояние автомата

      if (BeepEndProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      UstPower = 0; // Убираем мощность с ТЭНов
      break;
  }
}

//    case 110:
// Процесс дистилляции с подключаемым дефлегматором
// Процесс поддерживат температуру в дефлегматоре не более заданной + дельта и не менее заданной - дельта
void ProcessDistilDefl()
{

  // Если достигнут уровень в приемной емкости или температуре в кубе превысыла допустимую температуру для этого режима

  if ((flAlarmUroven || DS_TEMP(TEMP_KUB) >= tEndDistDefl || deltaPower >= Power) && StateMachine < 7)
  { // Переводим автомат в стадию завершения
    StateMachine = 7;
    SecondsEnd = 1 * 60;// Через одну минуту отключим воду
    SecTempPrev = Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }
  // Проверяем температуру в ТСА
  if (DS_TEMP(TEMP_TSA) >= MAX_TEMP_TSA)
  {
    StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
    UstPower = 0;
  }

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
      PrepareProcess();
      KlOpen[KLP_VODA] = PER_KLP_OPEN;
      KlClose[KLP_VODA] = PER_KLP_CLOSE;
      StateMachine = 2;//Этот процесс пока заблокирован, сразу идем на окончание.
      digitalWrite(PIN_RZG_ON, RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, !ALL_OFF_HIGH);
      flAllOff = 0;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      deltaPower = 0;
    case 2: // Ожидание, пока прогреется термометр в дефлегматоре

      UstPower = Power; // Устанавливаем максимальную мощность для разгона

      // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
      // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
      if (DS_TEMP(TEMP_DEFL) < TempDeflBegDistil && ds1820_devices > 1 || (TempDeflBegDistil < 0 && DS_TEMP(TEMP_KUB) < -TempDeflBegDistil)) break;

      // Подаем питание на клапан подачи воды холодильника
      StateMachine = 3;
      if (BeepStateProcess) my_beep(BEEP_LONG);

    case 3:
      // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
      // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
      if (DS_TEMP(TEMP_KUB) < TempDeflBegDistil) break;

      // Подаем питание на клапан подачи воды холодильника
      // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
      KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
      KlClose[KLP_HLD] = KlClose[KLP_VODA];
      KlState[KLP_HLD] = KlState[KLP_VODA];
      KlCount[KLP_HLD] = KlCount[KLP_VODA];

      StateMachine = 4;
      time2 = 15 * 60; // Взводиим таймер на 15 минут
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);

    case 4: // Дефлегматор отключен.
      // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
      if (time2 == 0)
      {
        deltaPower = deltaPower - (int)(PowerDistil / 20);
        if (deltaPower < 0) deltaPower = 0;
        time2 = 10 * 60;
      }

      UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.

      if (DS_TEMP(TEMP_DEFL) > TempDefl)
      {
        // Включаем дефлегматор и холодильник

        KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
        KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
        KlState[KLP_DEFL_D] = KlState[KLP_VODA];
        KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];

        KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
        KlClose[KLP_HLD] = KlClose[KLP_VODA];
        KlState[KLP_HLD] = KlState[KLP_VODA];
        KlCount[KLP_HLD] = KlCount[KLP_VODA];
        StateMachine = 5; // Переходим к этапу поддержания температуры путем частичной подачи воды в дефлегмато
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
        break;

    case 5:// 50% воды из холодильника идет в дефлегматор.
      // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
      time2 = 10 * 60;
      if (time3 == 0)
      {
        deltaPower = deltaPower - (int)(PowerDistil / 30);
        if (deltaPower < 0) deltaPower = 0;
        time3 = 10 * 60;
      }
      UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.
      // Если температура превысила температуру, которую надо поддерживать в дефлегматоре+дельта, тогда переходим к режиму, когда
      // вся вода из холодильника идет через дефлегматор
      if (DS_TEMP(TEMP_DEFL) > TempDefl + DeltaDefl)
      {
        // Отключаем прямой выход из холодильника
        KlOpen[KLP_HLD] = 0;
        KlClose[KLP_HLD] = 10;
        // Включаем дефлегматор
        KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
        KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
        KlState[KLP_DEFL_D] = KlState[KLP_VODA];
        KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];

        StateMachine = 6; // Переходим к этапу поддержания температуры путем 100% направления воды в дефлегматор
        time1 = 0;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else if (DS_TEMP(TEMP_DEFL) < TempDefl - DeltaDefl) // Если в результате работы с 50% дефлегматором, температура понизилась переходим в режим работы без дефлегматора
      {

        KlOpen[KLP_DEFL_D] = 0;
        KlClose[KLP_DEFL_D] = 10;

        KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
        KlClose[KLP_HLD] = KlClose[KLP_VODA];
        KlState[KLP_HLD] = KlState[KLP_VODA];
        KlCount[KLP_HLD] = KlCount[KLP_VODA];
        StateMachine = 4; // Переходим к этапу без дефлегмации
        if (BeepStateProcess) my_beep(BEEP_LONG);
        break;
      }
      else
        break;

    case 6: // Вся вода из холодильника идет в дефлегматор.
      // Взводиим таймер на 10 минут
      time3 = 10 * 60;
      UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.
      // Если температура превысила требуемую + дельта более, чем на полдельта за три минуты, тогда уменьшааем мощность
      if (DS_TEMP(TEMP_DEFL) > TempDefl + DeltaDefl + DeltaDefl / 2)
      {
        if (time1 == 0)
        {
          deltaPower = deltaPower + (int)(PowerDistil / 10);
          time1 = 3 * 60;// Взводим таймер на три минуты.
        }
      }

      if (DS_TEMP(TEMP_DEFL) < TempDefl) // Если в результате работы с 100% дефлегматором, температура понизилась ниже установленной температуры переходим в режим работы с 50% дефлегма
      {
        // Включаем прямой выход из холодильника.
        KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
        KlClose[KLP_HLD] = KlClose[KLP_VODA];
        KlState[KLP_HLD] = KlState[KLP_VODA];
        KlCount[KLP_HLD] = KlCount[KLP_VODA];

        KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
        KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
        KlState[KLP_DEFL_D] = KlState[KLP_VODA];
        KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];
        StateMachine = 5; // Переходим к этапу поддержания температуры 50% дефлегмацией
        time2 = 15 * 60; // Взводиим таймер на 15 минут
        if (BeepStateProcess) my_beep(BEEP_LONG);
        break;
      }
      else
        break;

    case 7:// Ждем минуту для окончания подачи воды
      UstPower = 0;
      SecondsEnd = SecondsEnd - (Seconds - SecTempPrev);
      SecTempPrev = Seconds;

      if (SecondsEnd <= 0)
      {
        // Переводим автомат в конечное состояние
        StateMachine = 100;
        SecondsEnd = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      break;
    default: // Phisik@24.02.2020: Любое ошибочное значение машины, должно приводить к остановке
    case 100:// Конечное состояние автомата
      if (BeepEndProcess) my_beep(BEEP_LONG);
    case 101:
      // Отключаем на всякий случай все!
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower = 0;
      CloseAllKLP();
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;

      break;
  }
}

//    case 117:
void ProcessDistillFractional()
{
  if (flAlarmUroven && StateMachine < 4)
  { // Если сработал датчик уровня, то переходим на следующую фракцию.
    TekFraction++;
    SecTempPrev = Seconds;
    flAlarmUroven = 0;
    CountAlarmUroven = 0;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  // Проверяем температуру в ТСА
  if (DS_TEMP(TEMP_TSA) >= MAX_TEMP_TSA)
  {
    StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
    UstPower = 0;
  }

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
      PrepareProcess();
      KlOpen[KLP_VODA] = PER_KLP_OPEN;
      KlClose[KLP_VODA] = PER_KLP_CLOSE;
      StateMachine = 2;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, !ALL_OFF_HIGH);
      flAllOff = 0;

    case 2: // Ожидание, пока прогреется термометр в дефлегматоре

      UstPower = Power; // Устанавливаем максимальную мощность для разгона
      // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
      // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
      if (DS_TEMP(TEMP_DEFL) < TempDeflBegDistil && ds1820_devices > 1 || (TempDeflBegDistil < 0 && DS_TEMP(TEMP_KUB) < -TempDeflBegDistil)) break;

      // Подаем питание на клапан подачи воды холодильника
      // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
      KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
      KlClose[KLP_HLD] = KlClose[KLP_VODA];
      KlState[KLP_HLD] = KlState[KLP_VODA];
      KlCount[KLP_HLD] = KlCount[KLP_VODA];
      StateMachine = 3;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
      TekFraction = 0;
      SecTempPrev = Seconds;

    case 3:// Ждем, пока температура в кубе не превысит установленную
      if (TekFraction < CountFractionDist)
      {
        if (TekFraction == 0 && CountFractionDist == 2) // Если число фракций равно ровно две, тогда отбираем первую фракцию через клапан голов, остальные через клапан тела
        {
          // Для первой фракции (считаем ее головами) открываем клапан отбора голов, клапан тела закрываем.
          KlOpen[KLP_SR] = 0;
          KlClose[KLP_SR] = 10;
          KlOpen[KLP_GLV_HVS] = 200;
          KlClose[KLP_GLV_HVS] = 0;
        }
        else
        { // Для последующих фракций (считаем их телом) клапан тела открываем, клапан голов закрываем.
          KlOpen[KLP_SR] = 200;
          KlClose[KLP_SR] = 0;
          KlOpen[KLP_GLV_HVS] = 0;
          KlClose[KLP_GLV_HVS] = 10;
        }
        UstPower = PowerFractionDist[TekFraction]; // Устанавливаем максимальную мощность для разгона
        TekTemp = TempFractionDist[TekFraction]; //Текущее состояние - первый недробный перегон
        if (TekTemp >= 0) // Значение больше нуля, значит это температура
        {
          if (DS_TEMP(TEMP_KUB) >= TekTemp)
          {
            TekFraction++;
            SecTempPrev = Seconds;
          }
        }
        else
        {
          // Значение меньше нуля, значит это время в минутах
          SecOstatok = -((Seconds - SecTempPrev) / 60 + TekTemp);
          // Если времени не осталось, переходим на следующую фракцию
          if (SecOstatok <= 0)
          {
            TekFraction++;
            SecTempPrev = Seconds;
          }
        }
        break;
      }
      else
      {
        StateMachine = 4;
        time3 = 2 * 60 * 60;// Через две минуты отключим воду
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
    case 4:// Ждем минуту для окончания подачи воды
      UstPower = 0;
      // Закрываем клапана на отбор.
      KlOpen[KLP_SR] = 0;
      KlClose[KLP_SR] = 10;
      KlOpen[KLP_GLV_HVS] = 0;
      KlClose[KLP_GLV_HVS] = 10;
      if (time3 == 0)
      {
        // Переводим автомат в конечное состояние
        StateMachine = 100;
        SecondsEnd = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      break;
    case 101: // Превышение температуры в ТСА!!!
      my_beep(3 * BEEP_LONG);
    default:// Phisik@24.02.2020: Любое ошибочное значение машины, должно приводить к остановке
    case 100:// Конечное состояние автомата
      // Отключаем на всякий случай все!
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower = 0;
      CloseAllKLP();
      //    digitalWrite(PIN_REG_ON,LOW);
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      break;
  }

}

//    case 104: //Текущее состояние - первый недробный перегон
//    case 106: //Текущее состояние - второй дробный
//    case 107: //Текущее состояние - третий дробный
//    case 105: //Текущее состояние - отбор голов

// Процесс отбора голов (без дефлегматора)
void ProcessSimpleGlv()
{
  if (flAlarmUroven && StateMachine < 4)
  { // Переводим автомат в стадию завершения 
    StateMachine = 4;
    SecondsEnd = 1 * 60;// Через одну минуту отключим воду
    SecTempPrev = Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  // Проверяем температуру в ТСА
  if (DS_TEMP(TEMP_TSA) >= MAX_TEMP_TSA)
  {
    StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
    UstPower = 0;
  }

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
      PrepareProcess();
      KlOpen[KLP_VODA] = PER_KLP_OPEN;
      KlClose[KLP_VODA] = PER_KLP_CLOSE;
      StateMachine = 2;
      digitalWrite(PIN_RZG_ON, RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, !ALL_OFF_HIGH);
      flAllOff = 0;

      if (BeepStateProcess) my_beep(BEEP_LONG);
    case 2: // Ожидание, пока прогреется термометр в дефлегматоре

      UstPower = Power; // Устанавливаем максимальную мощность для разгона

      // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
      // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
      if (DS_TEMP(TEMP_DEFL) < TempDeflBegDistil && ds1820_devices > 1 || (TempDeflBegDistil < 0 && DS_TEMP(TEMP_KUB) < -TempDeflBegDistil)) break;

      // Подаем питание на клапан подачи воды холодильника
      StateMachine = 3;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
      // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
      //if (DS_TEMP(TEMP_KUB)<TempDeflBegDistil) break;

      // Подаем питание на клапан подачи воды холодильника
      KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
      KlClose[KLP_HLD] = KlClose[KLP_VODA];
      KlState[KLP_HLD] = KlState[KLP_VODA];
      KlCount[KLP_HLD] = KlCount[KLP_VODA];
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
    case 3:// Работа в режиме отбра голов идет исключетельно по наполнению приемной емкости, но все-таки температуру
      // на всякий случай анализируем, ведь температура в кубе при отборе голов, в любом случае не может быть больше, чем температура окончания
      // третьей дробной перегонки

      UstPower = PowerGlvDistil; // Устанавливаем мощность отбора голов.
      // Клапан отбора голов устанавливаем, поскольку по совместительству этот режим может использоваться и для эпюрации
      // Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ

      if (DS_TEMP(TEMP_KUB) >= Temp3P)
      {
        StateMachine = 4;
        SecondsEnd = 1 * 60;// Через две минуты отключим воду
        SecTempPrev = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
        break;
    case 4:// Ждем минуту для окончания подачи воды
      UstPower = 0;
      // Подчиненные отключаем
      SecondsEnd = SecondsEnd - (Seconds - SecTempPrev);
      SecTempPrev = Seconds;

      if (SecondsEnd <= 0)
      {
        // Переводим автомат в конечное состояние
        StateMachine = 100;
        SecondsEnd = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      break;
    case 101: // Превышение температуры в ТСА!!!
      my_beep(3 * BEEP_LONG);
    default:// Phisik@24.02.2020: Любое ошибочное значение машины, должно приводить к остановке
    case 100:// Конечное состояние автомата
      // Отключаем на всякий случай все!
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower = 0;
      CloseAllKLP();
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      break;
  }
}

void ProcessSimpleDistill()
{

  if (flAlarmUroven && StateMachine < 4)
  { // Переводим автомат в стадию завершения 
    StateMachine = 4;
    SecondsEnd = 1 * 60;// Через две минуты отключим воду
    SecTempPrev = Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }
    
  // Проверяем температуру в ТСА
  if (DS_TEMP(TEMP_TSA) >= MAX_TEMP_TSA)
  {
    StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
    UstPower = 0;
  }

  switch (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
      PrepareProcess();
      KlOpen[KLP_VODA] = PER_KLP_OPEN;
      KlClose[KLP_VODA] = PER_KLP_CLOSE;
      StateMachine = 2;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, !ALL_OFF_HIGH);
      flAllOff = 0;

    case 2: // Ожидание, пока прогреется термометр в дефлегматоре

      UstPower = Power; // Устанавливаем максимальную мощность для разгона
      // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
      // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
      if (DS_TEMP(TEMP_DEFL) < TempDeflBegDistil && ds1820_devices > 1 || (TempDeflBegDistil < 0 && DS_TEMP(TEMP_KUB) < -TempDeflBegDistil)) 
      break;

      // Подаем питание на клапан подачи воды холодильника
      // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
      KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
      KlClose[KLP_HLD] = KlClose[KLP_VODA];
      KlState[KLP_HLD] = KlState[KLP_VODA];
      KlCount[KLP_HLD] = KlCount[KLP_VODA];
      StateMachine = 3;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);

    case 3:// Ждем, пока температура в кубе не превысит установленную
      UstPower = PowerDistil; // Устанавливаем максимальную мощность для разгона

      if (IspReg == 104) TekTemp = Temp1P; //Текущее состояние - первый недробный перегон
      if (IspReg == 106) TekTemp = Temp2P; //Текущее состояние - второй дробный
      if (IspReg == 107) TekTemp = Temp3P; //Текущее состояние - третий дробный

      if (DS_TEMP(TEMP_KUB) >= TekTemp)
      {
        StateMachine = 4;
        SecondsEnd = 1 * 60;// Через две минуты отключим воду
        SecTempPrev = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      else
        break;
    case 4:// Ждем минуту для окончания подачи воды
      UstPower = 0;
      SecondsEnd = SecondsEnd - (Seconds - SecTempPrev);
      SecTempPrev = Seconds;

      if (SecondsEnd <= 0)
      {
        // Переводим автомат в конечное состояние
        StateMachine = 100;
        SecondsEnd = Seconds;
        if (BeepStateProcess) my_beep(BEEP_LONG);
      }
      break;
    case 101: // Превышение температуры в ТСА!!!
      my_beep(3 * BEEP_LONG);
    default:// Phisik@24.02.2020: Любое ошибочное значение машины, должно приводить к остановке
    case 100:// Конечное состояние автомата
      // Отключаем на всякий случай все!
      if (BeepEndProcess) my_beep(BEEP_LONG);
      UstPower = 0;
      CloseAllKLP();
      digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
      digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
      flAllOff = 1;
      break;
  }

}
