// Последнее обновление 2018-09-15 by Phisik
// Файл содержит дефолтные настройки системы
// Часть настроек меняется в файле configuration.h при выборе версий, внимательно с этим!

#define PR_REWRITE_EEPROM 0 // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 

//=======================================================================================================
// Phisik: настройка UART для работы с периферией

#define DEBUG_SERIAL			 Serial  // Куда выводить отладку
#define DEBUG_SERIAL_BAUDRATE	 115200

#define MQTT_SERIAL				 Serial3  // Порт, к которому подключена ESP
#define MQTT_SERIAL_BAUDRATE	 115200   // Ставим максимальную, при которой еще нет ошибок связи
#define USE_MQTT_BROKER          1  // MQTT protocol by max506 & limon

//=======================================================================================================
// НАСТРОЙКА ЭКРАНА И КНОПОК

// USE_LCD_KEYPAD_SHIELD 1 - используется стандартный шильд с кнопками - один пин A0, на все кнопки 
                 
#define PRINT_ADC_VALUES 0	    // Phisik 2020-03-07: Выводить raw значения кнопок для отладки

#define MENU_DELAY_SEC  60			// Phisik 2020-03-07: Через сколько секунд надо выходить из меню

#define DEBOUNCE_CYCLES 15      // Число отсчетов таймера для устранения дребезга кнопок, 
// Phisik: было 20, и, как по мне, то кнопки тормозили

// предполагаем 2 байта на символ, в международной кодировке (UTF8 может быть 1-4 байта на символ)
#define LCD_BUFFER_SIZE  (16*2+2)
//=======================================================================================================
// ОБЩИЕ НАСТРОЙКИ

#define BEEP_LONG		15      // Длительность сигнала оповещения о состояниях процесса

// Phisik: Отключаем всякие надоедливые пищалки
#define NO_LOW_POWER_WARNING	 1
#define NO_DETECT_ZERO_WARNING   1
#define NO_PAGE_BEEP			 1  // Не пищать на 0ой странице

#define USE_BRESENHAM_ASC712	 0   // Надо ли регулировать мощность по алгоритму Брезенхема, используя пропуск полупериодов и только датчик
// Если USE_BRESENHAM_ASC712 = 0, то осуществляется фазовое регулирование
// Использование датчика тока при фазовом регулировании определяется переменной CorrectASC712

#define SENSITIVE_ASC712  205   // Чувствительность датчика тока (показаний АЦП ардуино на 10 ампер тока 135 для 30А датчика, 205 для 20А датчика 82)

#define CNT_PERIOD       4			// Количество полу-периодов для обсчета среднеквадратичного

#define USE_DIFAVTOMAT   0			// Константа, которая показывает, используется ли дифавтомат в работе системы
// нужно для того, чтобы при нормальном завершении процесса
// при плановом отключении дифавтомата не выдавалась тревога.

#define RELAY_HIGH       HIGH			// Какой сигнал подавать на релейные выходы мешалки и разгона 
#define ALL_OFF_HIGH     1			// Какой сигнал подавать на выход ALL_OFF

// Update 2018-09-15
// Phisik: сортировка датчиков температуры в меню
#define ENABLE_SENSOR_SORTING   0

// Update 2018-09-15
// Phisik: показывать температуру на 2ом экране с точкой в дробном виде
#define SHOW_FLOAT_TEMPERATURES   0

//=======================================================================================================
// НАСТРОЙКА КЛАПАНОВ

// Клапана для управления ШИМ подключены, начиная с PIN 22
// Всего максимум 5 клапанов, то есть на пины с 22 по 26 реализован
// программный ШИМ по количество полупериодов с контролем нуля.
//			Используйте 12ти вольтовые клапана и USE_12V_PWM = 1 для защиты от перегрева

#define KLP_HIGH 1				// Уровень на выходе для сработки клапана
// Для клапанов с низким уровнем управления поменять 0 на 1
#define PEREGREV_ON 0			// Защита от перегрева клапанов, 1- использовать, 0-нет.
#define USE_12V_PWM 1			// Phisik: Признак того, что надо использовать защиту от перегрева 12В клапанов 

#if PEREGREV_ON==0
#define PER_KLP_OPEN  1 // клапана открываем через полу-период (аналог диода), чтобы не перегревались и
#define PER_KLP_CLOSE 1 // чтобы не было гидроударов
#else
#define PER_KLP_OPEN  1000 // клапана на воду переводим в фазовое управление, чтобы раз в 10 секунд на них подавалось полное напряжение, а затем напряжение
#define PER_KLP_CLOSE 0    // из контанты U_PEREGREV 150 
#endif

#define MAX_KLP		   5      // Количество клапанов, которыми надо управлять по ШИМ. 

#define KLP_VODA     0      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL     1      // Номер клапана для подачи воды в дефлегматор
#define KLP_DEFL_D   2      // Номер клапана для подачи воды в дефлегматор при дистилляции с дефлегматором с паровым отбором
#define KLP_HLD      1      // Номер клапана холодильника для дистилляции
#define KLP_GLV_HVS  3      // Номер клапана отбора головных и хвостовых фракций
#define KLP_SR       4      // Номер клапана отбора ректификата

//=======================================================================================================
// АВАРИЙНАЯ СИГНАЛИЗАЦИЯ

#define USE_ALARM_UROVEN 1  // Нужно ли использовать датчик уровня в приемной емкости ардуино 
              //  1 - останавливать процесс при налолнении емкости, в т.ч. ректификацию
                            //  2 - останавливать отбор, но не останавливать ректификацию (остальные процессы останавливаются) 
#define UROVEN_ALARM     0    // Уровень сигнала, достижение котогого свидетельсвует о срабатывании аналогового датчика. 
                // В обычном состоянии он выведен на значение около 1000 для датчиков на уменьшение напряжения
                                // или на значение около 0-10 для датчиков на увеличение напряжения
                // Для цифрового датчика используем 1
#define COUNT_ALARM       6 // Сколько должно держаться значение уровня, чтобы сработало предупреждение каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN    200 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
 
//=======================================================================================================
// ДАТЧИКИ ТЕМПЕРАТУРЫ

#define MAX_DS1820		3

// Phisik: update 2018-07-25
// Номера датчиков теперь приведены в порядок. Если датчики определяются не в том порядке, меняем числа тут

#define TEMP_KUB       0    // Номер датчика  термометра в кубе
#define TEMP_DEFL      1    // Номер датчика термометра в дефлегматоре
#define TEMP_TSA       2    // Номер термометра в трубке связи с атмосферой
#define TEMP_TEMP_RK20 1    // Номер датчика  термометра в РК 20 см от насадки
#define TEMP_TERMOSTAT 0    // Номер датчика  термометра термостата

#define MAX_TEMP_TSA    550	  // Максимальная температура в датчике ТСА
#define MAX_ERR_DS18    120   // После тридцати глюков подряд (а это тридцать секунд) от датчиков температуры, считаем, что процесс надо остановить.

#define MAX_INDEX_INPUT 540

#define MAX_INDEX_BY_PERIOD 90
#define MIN_INDEX_BY_PERIOD 75

//=======================================================================================================
// РЕДАКТИРОВАНИЕ МЕНЮ

// Added by Phisik on 2017-08-15
// Здесь можно отключить ненужные нам пункты в меню

// NB! Пункты 129, 130 всегда должны быть в конце! Пункт 100 - вначале!
//     Это связано с обработчиком нажатий в файле keyboard.cpp, строки 600-630

#define MENU_ITEMS 21
const bool menuEnableFlag[MENU_ITEMS] = {
  1,    // case 100:  Установка параметров  // Не отключается!
  1,    // case 101:  Displaying   // Отключается, но отключаеть не стоит
  1,    // case 102:  Термостат
  1,    // case 103:  Регулятор мощности
  1,    // case 104:  Первый (недробный) отбор
  1,    // case 105:  Отбор голов
  1,    // case 106:  Второй дробный отбор
  1,    // case 107:  Третий дробный отбор
  0,    // case 108:  
  0,    // case 109:  
  1,    // case 110:  Дистилляция с дефлегматором
  0,    // case 111:  
  0,    // case 112:  
  0,    // case 113:  
  0,    // case 114:  
  1,    // case 115:  Таймер + регулятор мощности
  0,    // case 116:  
  1,    // case 117:  Фракционная перегонка
  0,    // case 118:  
  1,    // case 129:  Тест клапанов // Не отключается!
  0     // case 130:  
};

//=======================================================================================================
// РЕДАКТИРОВАНИЕ МЕНЮ НАСТРОЕК

// Здесь можно отключить ненужные нам пункты в меню настроек

#define SETTINGS_ITEMS 69

// Edited by Phisik on 2017-08-16
// Обновил алгоритм зацикливания. Теперь не надо задавать LAST_ITEM/FIRST_ITEM
// Просто расставить  1/0

const bool settingsEnableFlag[SETTINGS_ITEMS] = {
  1,    //  200: "Max_t_Tst=%5i"
  1,    //  201: "Power TEN=%5u"
  1,    //  202: "Power Reg=%5u"
  0,    //  203: ""
  0,    //  204: ""
  1,    //  205: "dtTermostat=%3i"
  1,    //  206: "Temp 1 Nedrobn Distill=%3i"
  1,    //  207: "Temp 2 Drobn Distill=%3i"
  0,    //  208: "Temp 3 Drobn Distill=%3i"
  0,    //  209: ""
  0,    //  210: ""
  1,    //  211: "Vvod Popravok ds18b20"
  0,    //  212: ""
  0,    //  213: ""
  0,    //  214: ""
  0,    //  215: ""
  0,    //  216: ""
  0,    //  217: ""
  0,    //  218: ""
  1,    //  219: "Power GLV simple Distill=%4i"
  1,    //  220: "Power simple Distill=%4i"
  1,    //  221: "Temp Begin Dist (+Def -Kub)=%3i"
  1,    //  222: "Temp Distill With Defl=%3i"
  1,    //  223: "Delta Distill With Defl=%3i"
  1,    //  224: "Temp Kub Okon DistWithDefl=%3i"
  0,    //  225: "BeepEndProc=%1u"
  0,    //  226: "BeepStateProc=%1u"
  0,    //  227: "BeepKeyPress=%1u"
  0,    //  228: ""
  1,    //  229: "Power Varka Zerno=%4i"
  0,    //  230: ""
  0,    //  231: "U Peregrev=%3uV"
  0,    //  232: ""
  0,    //  233: ""
  0,    //  234: ""
  0,    //  235: ""
  0,    //  236: ""
  0,    //  237: ""
  0,    //  238: ""
  0,    //  239: ""
  0,    //  240: ""
  1,    //  241: "Power correct ASC712 =%3i"
  0,    //  242: ""
  0,    //  243: ""
  0,    //  244: ""
  0,    //  245: ""
  0,    //  246: ""
  0,    //  247: ""
  0,    //  248: ""
  0,    //  249: "PID Paramters %4i %4i %4i"
  0,    //  250: ""
  0,    //  251: ""
  0,    //  252: ""
  0,    //  253: ""
  0,    //  254: ""
  0,    //  255: ""
  0,    //  256: ""
  1,    //  257: "Fraction Dist Count =%3i"
  0,    //  258: ""
  0,    //  259: ""
  0,    //  260: ""
  0,    //  261: ""
  0,    //  262: ""
  0,    //  263: ""
  0,    //  264: ""
  0,    //  265: ""
  0,    //  266: ""
  0,    //  267: ""
  0     //  268: ""
};

// =======================================================================================================
// ОТКЛЮЧЕНИЕ ЭКРАНОВ

// Здесь можно отключить ненужные нам экраны
#define SCREEN_ITEMS 11

// Edited by Phisik on 2018-07-03
// Обновил алгоритм зацикливания. Теперь не надо задавать LAST_ITEM/FIRST_ITEM
// Просто расставить  1/0

const bool screenEnableFlag[SCREEN_ITEMS] = {
  1, // D1   hour, minute, second. TicZero, MaxVoltsOut. 
  1, // D2   TEMP_KUB, TEMP_DEFL, TEMP_TSA, U_UROVEN.
  1, // D3   FactPower, MaxVoltsOut, MaxIOut.
  0, // D4   TEMP_KUB, TEMP_DEFL, TEMP_TSA.
  0, // D5   U_UROVEN. 
  1, // D6   zPSOut, UstPowerReg.
  0, // D7   TimeOpenTriac, TicZero, TimeOpenKLP, (int)b_value.
  1, // D8   StateMachine и смена состояния процесса.
  0, // D9   NewErr, OldErrOut, Dt, It.
  0, // D10  MAX_DS_TEMP(0), MAX_DS_TEMP(1), MAX_ DS_TEMP(2), MAX_DS_TEMP(3), MAX_DS_TEMP(4).
  0, // D11  NewErrTemp, OldErrTempOut, KtT, ItTemp, DtTemp.
};

// Update 2018-09-15
// Phisik: сортировка датчиков температуры по пресетам
// NB! Раньше сравнивались только первые датчики, теперь сравниваются все датчики в пресете
#define ENABLE_DS18B20_PRESET 0

#if ENABLE_DS18B20_PRESET
// Added by Phisik on 2017-08-16
// Ниже мы займемся сортировкой датчиков DS18B20, если датчики зафиксированы и никак их не поменять местами.
// Если у вас 1 комплект оборудования, то можно поменять выше TEMP_KUB/TEMP_RK20/TEMP_TSA и не включать сортировку.
// Если комплектов оборудования несколько, то придется сортировать

// Количество пресетов для датчиков, по ним потом будет сортировать те, что найдем
// Тут надо указать сколько у вас наборов
#define DS18B20_PRESET_NUM   1

// В этой переменной хранятся адреса нужных нам датчиков
// Я оставил здесь свои номера, вы ставьте свои.

// Адреса надо предварительно получить сканнером. Брать его в примерах File->Example->OneWire->ds18x20_temperature,
// здесь https://www.pjrc.com/teensy/td_libs_OneWire.html или  искать мои сообщения на HomeDistillers.
// Меняем пин OneWire на 37 - (OneWire  ds(37);), заливаем его на наш контроллер и топаем к колонне.
// Числа должны быть в шестнадцатеричной системе исчисления, т.е. дописываем 0x (ноль-икс)
// к тому, что выплюнет сканнер. Смотрим пример:

// Это получено от сканера:
//      ROM = 28 FF 30 6A A2 16 3 5A
//        Chip = DS18B20
//        Data = 1 B0 1 4B 46 7F FF C 10 9B  CRC=9B
//        Temperature = 27.00 Celsius, 80.60 Fahrenheit
//      ROM = 28 FF D5 FB A1 16 4 5B
//        Chip = DS18B20
//        Data = 1 AF 1 4B 46 7F FF C 10 35  CRC=35
//        Temperature = 26.94 Celsius, 80.49 Fahrenheit
//      ROM = 28 FF A7 34 A2 16 5 AC
//        Chip = DS18B20
//        Data = 1 B1 1 4B 46 7F FF C 10 D8  CRC=D8
//        Temperature = 27.06 Celsius, 80.71 Fahrenheit
//      No more addresses.

// Видим 3 датчика, их адреса "ROM = x x x x x x x ", и температуру каждого,
// греем те, до которых дотянемся, выясняем какой куда приварен. Далее формируем массив адресов
// датчиков, он трехмерный, стараемcя не запутаться в скобках, помним про ноль-икс!

const unsigned char dsSensorPreset[DS18B20_PRESET_NUM][MAX_DS1820][8] = {
  { // первый набор
    {0x28, 0xFF, 0xA7, 0x34, 0xA2, 0x16, 0x5, 0xAC},  // Первый датчик из первого набора
    {0x28, 0xFF, 0xD5, 0xFB, 0xA1, 0x16, 0x4, 0x5B},  // Второй датчик из первого набора
    {0x28, 0xFF, 0x30, 0x6A, 0xA2, 0x16, 0x3, 0x00},  // Третий датчик из первого набора
    {0, 0, 0, 0, 0, 0, 0, 0},                         // Если каких-то датчиков нет, то ставим нули
    {0, 0, 0, 0, 0, 0, 0, 0} // Запятую в конце перед фигурной скобкой не надо
  },
  { // Второй набор
    {0x28, 0xFF, 0x30, 0x6A, 0xA2, 0x16, 0x3, 0x5A},   // Первый датчик из второго набора
    {0x28, 0xFF, 0xA7, 0x34, 0xA2, 0x16, 0x5, 0xAC},   // Дальше я думаю все понятно...
    {0x28, 0xFF, 0xD5, 0xFB, 0xA1, 0x16, 0x4, 0x5B},
    {0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0}
  } // Тут тоже без запятой
}; // dsSensorPreset[][][]

#endif
