// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Все о клапанах тут
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "configuration.h"
#include "declarations.h"

// Процедура открывает клапана, которые необходимо открыть.

void OpenKLP()
{
  for (byte i=0;i<MAX_KLP;i++) {
    // Если клапан в режиме ШИМ и Состояние клапана включен, то включаем его 
        if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, KLP_HIGH); 
  }
}
  
void CloseAllKLP()
{
  // Все клапана зануляем.
  for (byte i = 0; i < MAX_KLP; i++) {
    KlOpen[i] = 0;
    KlClose[i] = 10;
    KlState[i] = 0;        // Начальное состояние - клапан закрыт, счетчик 0
    KlCount[i] = 0;
    KlReg[i] = PEREGREV_ON;
  }
}

// процесс 129
// Процедура по-очереди открывает клапана на несколько секунд
# define KPL_OPEN_TIME 2000

void ScanKLP()
{
  int i;
  {
    #if SIMPLED_VERSION<30
    lcd.clear();
    lcd.print(F("KLP VODA ON"));
    time3 = 10;
    for (i = 0; i < KPL_OPEN_TIME; i++)
    {
      digitalWrite(PIN_KLP_BEG + KLP_VODA, KLP_HIGH);
      delay(1);
    }
    lcd.clear();
    lcd.print(F("KLP HLD DIST ON"));
    for (i = 0; i < KPL_OPEN_TIME; i++)
    {
      digitalWrite(PIN_KLP_BEG + KLP_HLD, KLP_HIGH);
      delay(1);
    }
  }

  lcd.clear();
  lcd.print(F("KLP DEFL ON"));
  for (i = 0; i < KPL_OPEN_TIME; i++)
  {
    digitalWrite(PIN_KLP_BEG + KLP_DEFL, KLP_HIGH);
    delay(1);
  }

  lcd.clear();
  lcd.print(F("KLP GLV HVST ON"));
  for (i = 0; i < KPL_OPEN_TIME; i++)
  {
    digitalWrite(PIN_KLP_BEG + KLP_GLV_HVS, KLP_HIGH);
    delay(1);
  }

  lcd.clear();
  lcd.print(F("KLP SR ON"));
  for (i = 0; i < KPL_OPEN_TIME; i++)
  {
    digitalWrite(PIN_KLP_BEG + KLP_SR, KLP_HIGH);
    delay(1);
  }

#endif
}

// процесс 129
void ProcessTestKLP()
{
  switch  (StateMachine)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
      PrepareProcess();
      ProcChimSR = 2;
      ScanKLP();
      StateMachine = 2;
      if (BeepStateProcess) my_beep(BEEP_LONG);
      SecTempPrev = Seconds; // Запоминаем дату последнего изменения температуры
      if (SIMPLED_VERSION == 0) ProcChimSR = 95;
      else ProcChimSR = 4; // Если используется простая версия, то ШИМ всегда 50%, а процент ШИМ-Это номер тестируемого в данный момент клапана.
    // Чтобы при одновременном включении реле не происходил перезапуск контроллера.
    case 2: // Клапана открыты
      //    UstPower=500;
      if (SIMPLED_VERSION == 0) // В обычной версии тестируем клапана одновременно, с разным ШИМ
      {
        // Клапан Холодильника открыт
        KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
        KlClose[KLP_HLD] = KlClose[KLP_VODA];
        // Клапан дефлегматора открыт
        KlOpen[KLP_DEFL] = KlOpen[KLP_VODA];
        KlClose[KLP_DEFL] = KlClose[KLP_VODA];
        // Клапан отбора спирта открыт
        KlOpen[KLP_GLV_HVS] = KlOpen[KLP_VODA];
        KlClose[KLP_GLV_HVS] = KlClose[KLP_VODA];
        // Клапан отбора спирта открыт
        KlOpen[KLP_SR] = KlOpen[KLP_VODA];
        KlClose[KLP_SR] = KlClose[KLP_VODA];

      }
      else
      { // В упрощенной версии тестируем клапана по-очереди
        // ШИМ всегда 50%, в проценте ШИМ записан номер клапана.
        KlOpen[ProcChimSR] = 500;
        KlClose[ProcChimSR] = 500;
      }
      if (Seconds - SecTempPrev > 600) // Если с момента запуска прошло более 10 минут, то переходим в режим паузы - 1 минута.
      {
        if (BeepStateProcess) my_beep(BEEP_LONG);
        SecTempPrev = Seconds; // Запоминаем время паузы.
        StateMachine = 3;
        // Закрываем все клапана.
        if (SIMPLED_VERSION == 0)
        {
          ProcChimSR -= 5;
          if (ProcChimSR <= 0) ProcChimSR = 100;
        }
        else
        { // Тестируем клапана.
          ProcChimSR++;
          if (ProcChimSR > 4) ProcChimSR = 2;
        }
        CloseAllKLP();
      }
      break;
    case 3: // Клапана закрыты, ждем 1 минуту
      if (Seconds - SecTempPrev > 60) // Если с момента запуска прошло более 20 минут, то переходим в режим паузы - 1 минута.
      {
        if (BeepStateProcess) my_beep(BEEP_LONG);
        StateMachine = 2;
      }
      break;
    case 100:
      CloseAllKLP();
      break;
  }
}
